local SmokeHouse = ...

-- Register prefab nodes (currently only one core model)
SmokeHouse:registerAssetId("models/FishSmokeHouse.fbx/Prefab/smokeHousePart", "FISH_SMOKEHOUSE_WORKPLACE_PREFAB")

SmokeHouse:register({
--Dclare que l'objet que l'on cre appartient  la class BUILDING
	DataType = "BUILDING",
--Dclare la classe de l'objet que l'on cre
	Id = "FISH_SMOKEHOUSE_WORKPLACE",
	Name = "FISH_SMOKEHOUSE_WORKPLACE_NAME",
	Description = "FISH_SMOKEHOUSE_WORKPLACE_DESC",
--Renseigne le champ Building Type. cela va permettre de classer l'objet dans les menus
	BuildingType = "GENERAL",
--renseigne le champ BuildingPartList de l'objet que l'on cre un peu plus loin	
	BuildingPartSetList = {
		{
			Name = "FISH_SMOKEHOUSE_WORKPLACE_PARTSETLIST_NAME",
	                BuildingPartList = { "FISH_SMOKEHOUSE_WORKPLACE_PART" }
                }
        }
--Renseigne le champ Nombre de villageois requis pour la construction. Ici inactiv pour le test
	--VillagerRequired = { Status = "NEWCOMER", Quantity = 9 }
})

-- Register the shoemaker workplace part
SmokeHouse:register({
	DataType = "BUILDING_PART",
	Id = "FISH_SMOKEHOUSE_WORKPLACE_PART",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "FISH_SMOKEHOUSE_WORKPLACE_PREFAB"
	},
--Dclaration de la taille de la zone de construction ( c'est un masque qui cache la zone de futur construction pour faire passer devant le decor votre object" veiller a la faire a la bonne taille ..pas bloquant
	BuildingZone = { 4, 4},
--Ca c'est pour dclarer le visuel de construction si il y en a un !
	ConstructionVisual = "FISH_SMOKEHOUSE_WORKPLACE_PREFAB",
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 10 }
		}
	},
	BuildingFunction = {
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Type = "FOOD",
		WorkerCapacity = 1,
                RelatedJob = { Job = "FISHERMAN", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "FISH", Quantity = 50 },
                	{ Resource = "SALT2", Quantity = 50 },
                	{ Resource = "WOOD", Quantity = 50 }
                },
                ResourceListNeeded = {
                	{ Resource = "FISH", Quantity = 4 },
                	{ Resource = "SALT2", Quantity = 1 },
                	{ Resource = "WOOD", Quantity = 2 }
                },
                ResourceProduced = {
			{ Resource = "SALTING", Quantity = 4 }
                }
	}
})

-- Register air vent particle system
SmokeHouse:registerAssetId("models/FishSmokeHouse.fbx/Prefab/smokeHousePart/step_2/cheminee/SmokeEmitter", "FISH_SMOKEHOUSE_EMITTER_PREFAB")

SmokeHouse:registerPrefabComponent("models/FishSmokeHouse.fbx/Prefab/smokeHousePart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { "FISH_SMOKEHOUSE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

SmokeHouse:registerPrefabComponent("models/FishSmokeHouse.fbx/Prefab/smokeHousePart/step_2/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = false
})

SmokeHouse:registerPrefabComponent("models/FishSmokeHouse.fbx/Prefab/smokeHousePart/step_2/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})


-- Register prefab nodes (currently only one core model)
SmokeHouse:registerAssetId("models/DeerSmokeHouse.fbx/Prefab/smokeHousePart", "DEER_SMOKEHOUSE_WORKPLACE_PREFAB")

SmokeHouse:register({
--Dclare que l'objet que l'on cre appartient  la class BUILDING
	DataType = "BUILDING",
--Dclare la classe de l'objet que l'on cre
	Id = "DEER_SMOKEHOUSE_WORKPLACE",
	Name = "DEER_SMOKEHOUSE_WORKPLACE_NAME",
	Description = "DEER_SMOKEHOUSE_WORKPLACE_DESC",
--Renseigne le champ Building Type. cela va permettre de classer l'objet dans les menus
	BuildingType = "GENERAL",
--renseigne le champ BuildingPartList de l'objet que l'on cre un peu plus loin	
	BuildingPartSetList = {
		{
			Name = "DEER_SMOKEHOUSE_WORKPLACE_PARTSETLIST_NAME",
	                BuildingPartList = { "DEER_SMOKEHOUSE_WORKPLACE_PART" }
                }
        }
--Renseigne le champ Nombre de villageois requis pour la construction. Ici inactiv pour le test
	--VillagerRequired = { Status = "NEWCOMER", Quantity = 9 }
})

-- Register the shoemaker workplace part
SmokeHouse:register({
	DataType = "BUILDING_PART",
	Id = "DEER_SMOKEHOUSE_WORKPLACE_PART",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "DEER_SMOKEHOUSE_WORKPLACE_PREFAB"
	},
--Dclaration de la taille de la zone de construction ( c'est un masque qui cache la zone de futur construction pour faire passer devant le decor votre object" veiller a la faire a la bonne taille ..pas bloquant
	BuildingZone = { 4, 4},
--Ca c'est pour dclarer le visuel de construction si il y en a un !
	ConstructionVisual = "DEER_SMOKEHOUSE_WORKPLACE_PREFAB",
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 10 }
		}
	},
	BuildingFunction = {
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Type = "FOOD",
		WorkerCapacity = 1,
                RelatedJob = { Job = "HUNTER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "DEER", Quantity = 50 },
                	{ Resource = "SALT2", Quantity = 50 },
                	{ Resource = "WOOD", Quantity = 50 }
                },
                ResourceListNeeded = {
                	{ Resource = "DEER", Quantity = 4 },
                	{ Resource = "SALT2", Quantity = 1 },
                	{ Resource = "WOOD", Quantity = 2 }
                },
                ResourceProduced = {
			{ Resource = "SALTING", Quantity = 4 }
                }
	}
})

-- Register air vent particle system
SmokeHouse:registerAssetId("models/DeerSmokeHouse.fbx/Prefab/smokeHousePart/step_2/cheminee/SmokeEmitter", "DEER_SMOKEHOUSE_EMITTER_PREFAB")

SmokeHouse:registerPrefabComponent("models/DeerSmokeHouse.fbx/Prefab/smokeHousePart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
                 { "DEER_SMOKEHOUSE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

SmokeHouse:registerPrefabComponent("models/DeerSmokeHouse.fbx/Prefab/smokeHousePart/step_2/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = false
})

SmokeHouse:registerPrefabComponent("models/DeerSmokeHouse.fbx/Prefab/smokeHousePart/step_2/cheminee/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})
